/* global conjur */

'use strict';

var polyfill = require('event-source-polyfill'),
    request = require('superagent');

var c = module.exports.c = {
    AUDIT_ALL: 'AUDIT_ALL',
    AUDIT_FLOW: 'AUDIT_FLOW',
    AUDIT_ROLE: 'AUDIT_ROLE',
    AUDIT_RESOURCE: 'AUDIT_RESOURCE'
};

module.exports.fetch = function(type, kind, id, callback, errCallback) {
    var defaultCallback = function(res) {
        if (res.error) {
            errCallback(res);
        } else {
            callback(res);
        }
    };

    var fullId = window.encodeURIComponent(conjur.app.configuration.account +
                                           ':' + kind + ':' + id);

    switch (type) {
    case c.AUDIT_ALL:
        request
            .get('/api/audit/all')
            .end(defaultCallback);
        break;

    case c.AUDIT_FLOW:
        var e = new EventSource('/api/audit/all');
        e.onmessage = callback;
        e.onerror = errCallback;
        return e;

        break;

    case c.AUDIT_ROLE:
        request
            .get('/api/audit/roles/' + fullId)
            .end(defaultCallback);
        break;

    case c.AUDIT_RESOURCE:
        request
            .get('/api/audit/resources/' + fullId)
            .end(defaultCallback);
        break;
    };
};
