/* global conjur */

'use strict';

var request = require('superagent');

var c = module.exports.c = {
    LAYER_MEMBERS_USE: 'LAYER_MEMBERS_USE',
    LAYER_MEMBERS_ADMIN: 'LAYER_MEMBERS_ADMIN'
};

module.exports.fetch = function(type, id, callback, errCallback) {
    var defaultCallback = function(res) {
        if (res.error) {
            errCallback(res);
        } else {
            callback(res);
        }
    };

    var role = '';

    if (type === c.LAYER_MEMBERS_USE) {
        role = '@/layer/' + id + '/use_host';
    } else if (type === c.LAYER_MEMBERS_ADMIN) {
        role = '@/layer/' + id + '/admin_host';
    }

    request
        .get('/api/authz/' +
             conjur.app.configuration.account +
             '/roles/' +
             role +
             '?members')
        .end(defaultCallback);
};
