/* global conjur */

'use strict';

var request = require('superagent');

module.exports.fetch = function(kind, callback, errCallback) {
    var defaultCallback = function(res) {
        if (res.error) {
            errCallback(res);
        } else {
            callback(res);
        }
    };

    if (kind === 'custom-type') {
        request
            .get('/api/authz/' +
                 window.encodeURIComponent(conjur.app.configuration.account) +
                 '/resources')
            .end(defaultCallback);
    } else {
        request
            .get('/api/authz/' +
                 window.encodeURIComponent(conjur.app.configuration.account) +
                 '/resources/' +
                 window.encodeURIComponent(kind))
            .end(defaultCallback);
    }
};

module.exports.fetchOne = function(kind, id, callback, errCallback) {
    var defaultCallback = function(res) {
        if (res.error) {
            errCallback(res);
        } else {
            callback(res);
        }
    };

    request
        .get('/api/authz/' +
             window.encodeURIComponent(conjur.app.configuration.account) +
             '/resources/' +
             window.encodeURIComponent(kind) +
             '/' +
             window.encodeURIComponent(id))
        .end(defaultCallback);
};

module.exports.fetchGroupRoles = function(id, callback, errCallback) {
    request
        .get('/api/authz/' +
             conjur.app.configuration.account +
             '/roles/group/' +
             id +
             '?members')
        .end(function(res) {
            if (res.error) {
                errCallback(res);
            } else {
                callback(res);
            }
        });
};

module.exports.fetchResources = function(kind, id, callback, errCallback) {
    var role = escape(conjur.app.configuration.account + ':' + kind + ':' + id);

    request
        .get('/api/authz/' +
             conjur.app.configuration.account +
             '/resources?acting_as=' +
             role)
        .end(function(res) {
            if (res.error) {
                errCallback(res);
            } else {
                callback(res);
            }
        });
};
