/* global conjur */

'use strict';

var request = require('superagent');

var c = module.exports.c = {
    MEMBERS_EXECUTE: 'MEMBERS_EXECUTE',
    MEMBERS_UPDATE: 'MEMBERS_UPDATE'
};

module.exports.fetch = function(asset_type, type, id, callback, errCallback) {
    var defaultCallback = function(res) {
        if (res.error) {
            errCallback(res);
        } else {
            callback(res);
        }
    };

    var privilege = '';

    if (type === c.MEMBERS_EXECUTE) {
        privilege = 'execute';
    } else if (type === c.MEMBERS_UPDATE) {
        privilege = 'update';
    }

    request
        .get('/api/authz/' +
             conjur.app.configuration.account +
             '/roles/allowed_to/' +
             privilege + '/' +
             asset_type + '/' +
             window.encodeURIComponent(id))
        .end(defaultCallback);
};
