'use strict';

var React = require('react'),
    Router = require('react-router'),
    RouteHandler = Router.RouteHandler,
    Fluxxor = require('fluxxor'),
    FluxMixin = Fluxxor.FluxMixin(React),
    StoreWatchMixin = Fluxxor.StoreWatchMixin;

var Navbar = require('../navbar/navbar'),
    Flash = require('../flash/flash');

module.exports = React.createClass({
    displayName: 'App',

    mixins: [FluxMixin, StoreWatchMixin('AppStore')],

    getStateFromFlux() {
        var flux = this.getFlux();

        return flux.store('AppStore').getState();
    },

    getDefaultProps() {
        return {
            userId: conjur.app.userId
        };
    },

    render() {
        var flash;

        if (typeof this.state.flash.msg === 'string') {
            flash = (
              <Flash msg={this.state.flash.msg}
                     handleClose={this.handleFlashClose} />
            );
        }

        return (
          <div className="container">
            <Navbar userId={this.props.userId} />
            {flash}
            <div id="modal"></div>
            <div id="content">
              <RouteHandler />
            </div>
            <div id="bottom" className="navbar-default">
              <a href="http://conjur.net" className="nav-item"
                 target="_blank">&copy; 2014, Conjur Inc.</a>
            </div>
          </div>
        );
    },

    handleFlashClose() {
        this.setState({flash: {}});
    },

    componentDidMount() {
        var flux = this.getFlux();

        flux.actions.audit.loadAll(true);
        flux.actions.resources.load('custom-type');
    }
});
