'use strict';

var React = require('react');

var DropdownButton = require('react-bootstrap/lib/DropdownButton'),
    Navbar = require('react-bootstrap/lib/Navbar'),
    Nav = require('react-bootstrap/lib/Nav'),
    MenuItem = require('react-bootstrap/lib/MenuItem');

var NavItemLink = require('react-router-bootstrap/lib/NavItemLink'),
    MenuItemLink = require('react-router-bootstrap/lib/MenuItemLink');

var NavSearchForm = require('./nav_search_form'),
    RoleLink = require('../generic/role_link');

module.exports = React.createClass({
    displayName: 'Navbar',

    render() {
        var style = {
            backgroundPositionY: '0.8em'
        };

        var listStyle = {
            marginRight: '15px'
        };

        return (
          <Navbar brand="Conjur">
            <Nav eventKey={0}>
              <NavItemLink to="dashboard">
                Dashboard
              </NavItemLink>
              <DropdownButton eventKey={3} title="Directory">
                <MenuItemLink to="users">
                  Users
                </MenuItemLink>
                <MenuItemLink to="groups">
                  Groups
                </MenuItemLink>
                <MenuItem divider />
                <MenuItemLink to="hosts">
                  Hosts
                </MenuItemLink>
                <MenuItemLink to="layers">
                  Layers
                </MenuItemLink>
                <MenuItem divider />
                <MenuItemLink to="variables">
                  Variables
                </MenuItemLink>
                <MenuItemLink to="custom-types">
                  Custom Types
                </MenuItemLink>
              </DropdownButton>
              <NavItemLink to="policies">
                Policies
              </NavItemLink>
            </Nav>
            <Nav right eventKey={1} style={listStyle}>
              <li>
                <RoleLink id={this.props.userId} style={style} />
              </li>
              <li>
                <NavSearchForm />
              </li>
            </Nav>
          </Navbar>
        );
    }
});
