'use strict';

var React = require('react');

var Router = require('react-router'),
    Route = Router.Route,
    DefaultRoute = Router.DefaultRoute;

var App = require('./components/app/app'),
    Dashboard = require('./components/dashboard/dashboard'),
    Search = require('./components/search/search');

var UserList = require('./components/user/list'),
    UserView = require('./components/user/view'),
    GroupList = require('./components/group/list'),
    GroupView = require('./components/group/view'),
    HostList = require('./components/host/list'),
    HostView = require('./components/host/view'),
    LayerList = require('./components/layer/list'),
    LayerView = require('./components/layer/view'),
    VariableList = require('./components/variable/list'),
    VariableView = require('./components/variable/view'),
    PolicyList = require('./components/policy/list'),
    PolicyView = require('./components/policy/view'),
    CustomList = require('./components/custom/list'),
    CustomView = require('./components/custom/view');

module.exports = (
  <Route path="/ui" handler={App}>
    <Route name="dashboard" path="/ui" handler={Dashboard} />

    <Route name="users" handler={UserList} />
    <Route name="user" path="/ui/users/:id" handler={UserView} />

    <Route name="groups" handler={GroupList} />
    <Route name="group" path="/ui/groups/:id" handler={GroupView} />

    <Route name="hosts" handler={HostList} />
    <Route name="host" path="/ui/hosts/:id" handler={HostView} />

    <Route name="layers" handler={LayerList} />
    <Route name="layer" path="/ui/layers/:id" handler={LayerView} />

    <Route name="variables" handler={VariableList} />
    <Route name="variable" path="/ui/variables/:id" handler={VariableView} />

    <Route name="policies" handler={PolicyList} />
    <Route name="policy" path="/ui/policies/:id" handler={PolicyView} />

    <Route name="custom-types" handler={CustomList} />
    <Route name="custom-type" path="/ui/custom-type/:kind/:id" handler={CustomView} />

    <Route name="search" path="/ui/search/:query" handler={Search} />

    <DefaultRoute handler={Dashboard} />
  </Route>
);
