'use strict';

var Fluxxor = require('fluxxor');

var constants = require('../constants');

module.exports = Fluxxor.createStore({
    initialize: function() {
        this.path = '';
        this.flash = {};

        this.bindActions(
            constants.FLASH_MESSAGE, this.onFlashMessage
        );
    },

    onFlashMessage(payload) {
        this.flash.msg = payload.msg;
        this.flash.status = payload.status;
        this.emit('change');
    },

    getState() {
        return {
            path: this.path,
            flash: this.flash
        };
    }
});
