'use strict';

var Fluxxor = require('fluxxor');

var constants = require('../constants');

var RouteStore = Fluxxor.createStore({
    initialize() {
        this.params = {};

        this.bindActions(
            constants.ROUTES.TRANSITION, this.handleRouteTransition
        );
    },

    handleRouteTransition(payload) {
        this.params = payload.params;
        this.emit('change');
    },

    getParam(param) {
        return unescape(this.params[param]);
    }
});

module.exports = RouteStore;
