'use strict';

module.exports.errback = function(err) {
    console.log('error:', err);
};

module.exports.pluralize = function(kind) {
    if (kind[kind.length-1] === 'y') {
        return kind.slice(0, kind.length-1) + 'ies';
    } else if (kind[kind.length - 1] !== 's') {
        return kind + 's';
    } else {
        return kind;
    }
};

// http://www.quirksmode.org/js/cookies.html
module.exports.readCookie = function(name) {
    var nameEQ = name + '=',
        ca = document.cookie.split(';');

    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];

        while (c.charAt(0) === ' ') {
            c = c.substring(1, c.length);
        }

        if (c.indexOf(nameEQ) === 0) {
            return c.substring(nameEQ.length, c.length);
        }
    }

    return null;
};

module.exports.getTabname = function(header, set) {
    if (!set || !set.length) {
        return header + ' (0)';
    }

    return header + ' (' + set.length + ')';
};
